<template>
  <ms-modal
    :v-model="vModel"
    :id="GLOBALS.__APP_NAME__ + '-edit-source-modal'"
    :title="$h.capitalize($t(`${GLOBALS.__T_PREFIX__}.modals.editSource.title`))"
    :ok="ok"
    :ok-title="$h.capitalize($t(`${GLOBALS.__T_PREFIX__}.modals.editSource.okTitle`))"
    :ok-state="isValid"
    :cancel="cancel"
    :cancel-title="$h.capitalize($t(`global.cancel`))"
    :hide-buttons="!showModalContent"
    @ok="$emit('ok')"
    @cancel="$emit('cancel')"
  >
    <transition
      mode="out-in"
      enter-active-class="animated fadeIn fast"
      leave-active-class="animated fadeOut fast"
    >
      <div :id="GLOBALS.__APP_NAME__ + '-edit-source-modal'" v-if="showModalContent" key="modal-content">
        <b-form class="mb-3">
          <!-- Category label -->
          <label for="edit-source-select-category">{{ $t(`${GLOBALS.__T_PREFIX__}.global.category`) | capitalize }}:</label>
          <!-- Category select -->
          <v-select
            :placeholder="$h.capitalize($t('global.choose'))"
            label="label"
            v-model="editedFeed.category_id"
            :reduce="category => category.id"
            :options="categories"
            class="mb-2"
          />
          <!-- Label input -->
          <b-form-group
            id="input-group-label"
            :label="$h.capitalize($t(`${GLOBALS.__T_PREFIX__}.global.label`) + ':')"
            label-for="edit-source-input-label"
          >
            <b-form-input
              v-model="editedFeed.label"
              id="edit-source-input-label"
              type="text"
              :state="labelState"
              required
              placeholder="Label"
              class="ms_input mb-2"
            />
          </b-form-group>
          <!-- URL input -->
          <b-form-group
            id="input-group-url"
            label="URL:"
            label-for="add-source-input-url"
          >
            <!--
              Input: note that debounce is activated
              v-model is updated after 3000ms on key up/change
            -->
            <b-form-input
              v-model="editedFeed.url"
              id="add-source-input-url"
              type="text"
              :state="urlState"
              required
              placeholder="https://"
              class="ms_input"
              debounce="2000"
            />
          </b-form-group>
          <!-- URL validation message -->
          <div v-if="isParsingUrl">
            <p>{{ $t(`${GLOBALS.__T_PREFIX__}.modals.addSource.checkUrlMessage`) }}</p>
          </div>
          <div v-if="!isParsingUrl && editedFeed.validSource">
            <p>{{ editedFeed.validSource.title }} ({{ editedFeed.validSource.feedUrl }})</p>
          </div>
          <div v-if="!isParsingUrl && !editedFeed.validSource && editedFeed.url.length > 0">
            <p>{{ $t(`${GLOBALS.__T_PREFIX__}.modals.addSource.notFoundMessage`) }}</p>
          </div>
          <div v-if="!isParsingUrl && editedFeed.url.length === 0">
            <p>{{ $t(`${GLOBALS.__T_PREFIX__}.modals.addSource.pleaseEnterUrlMessage`) }}</p>
          </div>
        </b-form>
        <!-- Delete button -->
        <p class="edit-source-delete-button" @click="handleDelete">
          <v-icon name="times-circle"></v-icon>
          <span>{{ $t(`${GLOBALS.__T_PREFIX__}.modals.editSource.deleteSource`) | capitalize }}</span>
        </p>
      </div>
      <div v-else key="modal-loading">
        <icon-basic-load width="28" height="28"/>
        <span>{{ $t("global.loading") }}</span>
      </div>
    </transition>
    <!-- Confirm deleting modal -->
    <ms-modal
      :v-model="showConfirmDeleting"
      :id="GLOBALS.__APP_NAME__ + '-delete-source-modal'"
      :ok="deleteFeed"
      :ok-title="$h.capitalize($t(`global.confirm`))"
      :cancel="cancelDelete"
      :cancel-title="$h.capitalize($t(`global.cancel`))"
    >
      <p>{{ $t(`${GLOBALS.__T_PREFIX__}.modals.deleteSource.confirmDeleteMessage`) }}</p>
    </ms-modal>
  </ms-modal>
</template>

<script>
import { BaseComponent } from '@/utils/'

export default {
  extends: BaseComponent,
  data () {
    return {
      editedFeed: null, // Init in mounted ()
      isParsingUrl: false,
      showConfirmDeleting: false
    }
  },
  computed: {
    categoryState: function () {
      return this.editedFeed.category_id
    },
    labelState: function () {
      return this.editedFeed.label.length > 0
    },
    urlState: function () {
      return this.editedFeed.validSource !== false
    },
    isValid: function () {
      if (this.editedFeed && this.categoryState && this.labelState && this.urlState) {
        return true
      } else {
        return false
      }
    },
    showModalContent: function () {
      if (!this.feedsDeleting && !this.feedsUpdating && this.editedFeed) {
        return true
      } else {
        return false
      }
    }
  },
  props: {
    // V-Model: to show the modal
    vModel: {
      type: Boolean,
      default: false
    },
    // Feed object
    feed: Object
  },
  methods: {
    ok: async function () {
      const editedFeed = await this.updateFeeds({
        id: this.editedFeed.id,
        label: this.editedFeed.label,
        url: this.editedFeed.validSource.feedUrl,
        category_id: this.editedFeed.category_id
      })
      if (editedFeed instanceof Error) {
        return false
      }
      // Update feeds
      const feeds = this.feeds
      this.feeds.forEach((feed, index) => {
        if (feed.id === editedFeed.id) {
          feeds[index] = editedFeed
        }
      })
      this.SET_FEEDS(feeds)
      // Load data
      this.loadFeedData(editedFeed.id)
      return true
    },
    cancel: function () {
      return true
    },
    handleDelete: function () {
      this.showConfirmDeleting = true
    },
    cancelDelete: function () {
      this.showConfirmDeleting = false
    },
    deleteFeed: async function () {
      this.showConfirmDeleting = false
      // Try to delete feed
      const feedId = this.feed.id
      const deleteResponse = await this.deleteFeeds({
        id: this.feed.id
      })
      // If success
      if (!(deleteResponse instanceof Error)) {
        // Clean feeds for deleted category
        const cleanedFeeds = this.feeds.reduce((array, feed) => {
          if (feed.id !== feedId) {
            array.push(feed)
          }
          return array
        }, [])
        this.SET_FEEDS(cleanedFeeds)
      }
      this.$emit('ok') // To close modal after deleting
      return true
    }
  },
  state: {
    MyFeedsModule: [
      'feeds',
      'categories',
      'feedsUpdating',
      'feedsDeleting',
      'parser',
      'corsProxy'
    ]
  },
  actions: {
    MyFeedsModule: [
      'updateFeeds',
      'deleteFeeds',
      'loadFeedData'
    ]
  },
  mutations: {
    MyFeedsModule: [
      'SET_FEEDS'
    ]
  },
  mounted () {
    if (this.feed) {
      this.editedFeed = {
        ...this.feed,
        validSource: {
          title: this.feed.data.title,
          feedUrl: this.feed.url
        }
      }
    } else {
      this.editedFeed = null
    }
  },
  watch: {
    'editedFeed.url': async function (to, from) {
      if (from !== undefined) {
        this.editedFeed.validSource = false
        this.isParsingUrl = true
        // If url valid
        if (this.$h.isValidHttpUrl(to) instanceof URL) {
          try {
            const data = await this.parser.parseURL(this.corsProxy + this.editedFeed.url)
            this.editedFeed.validSource = data
          } catch (error) {
            this.editedFeed.validSource = false
          }
        }
        this.isParsingUrl = false
      }
    },
    feed: function (to, from) {
      this.editedFeed = {
        ...this.feed,
        validSource: {
          title: this.feed.data.title,
          feedUrl: this.feed.url
        }
      }
    }
  }
}
</script>
